(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/material')) :
    typeof define === 'function' && define.amd ? define('ngx-mat-popover', ['exports', '@angular/common', '@angular/core', '@angular/material'], factory) :
    (factory((global['ngx-mat-popover'] = {}),global.ng.common,global.ng.core,global.ng.material));
}(this, (function (exports,common,i0,material) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxMatPopoverService = /** @class */ (function () {
        function NgxMatPopoverService() {
        }
        NgxMatPopoverService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxMatPopoverService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxMatPopoverService.ngInjectableDef = i0.defineInjectable({ factory: function NgxMatPopoverService_Factory() { return new NgxMatPopoverService(); }, token: NgxMatPopoverService, providedIn: "root" });
        return NgxMatPopoverService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxMatPopoverComponent = /** @class */ (function () {
        function NgxMatPopoverComponent() {
            this.xPosition = 'after';
            this.yPosition = 'below';
        }
        // for outside call
        // for outside call
        /**
         * @return {?}
         */
        NgxMatPopoverComponent.prototype.open =
            // for outside call
            /**
             * @return {?}
             */
            function () {
                this.matMenuTrigger.openMenu();
            };
        /**
         * @return {?}
         */
        NgxMatPopoverComponent.prototype.close = /**
         * @return {?}
         */
            function () {
                this.matMenuTrigger.closeMenu();
            };
        NgxMatPopoverComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-mat-popover',
                        template: "<mat-menu #popover=\"matMenu\" [xPosition]=\"xPosition\" [yPosition]=\"yPosition\" class=\"ngm-popover\">\n  <ng-template matMenuContent>\n    <span mat-menu-item [disableRipple]=\"true\" (click)=\"$event.stopPropagation()\" class=\"mat-popover\">\n      <!-- popover content begin -->\n      <ng-container *ngTemplateOutlet=\"popoverContent\"></ng-container>\n      <!-- popover content end  -->\n    </span>\n  </ng-template>\n</mat-menu>\n<div [matMenuTriggerFor]=\"popover\">\n  <ng-content></ng-content>\n</div>\n",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        exportAs: 'ngxMatPopover'
                    }] }
        ];
        NgxMatPopoverComponent.propDecorators = {
            xPosition: [{ type: i0.Input }],
            yPosition: [{ type: i0.Input }],
            popoverContent: [{ type: i0.Input }],
            matMenuTrigger: [{ type: i0.ViewChild, args: [material.MatMenuTrigger,] }]
        };
        return NgxMatPopoverComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxMatPopoverModule = /** @class */ (function () {
        function NgxMatPopoverModule() {
        }
        NgxMatPopoverModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [NgxMatPopoverComponent],
                        imports: [common.CommonModule, material.MatMenuModule],
                        exports: [NgxMatPopoverComponent]
                    },] }
        ];
        return NgxMatPopoverModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxMatPopoverService = NgxMatPopoverService;
    exports.NgxMatPopoverComponent = NgxMatPopoverComponent;
    exports.NgxMatPopoverModule = NgxMatPopoverModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-mat-popover.umd.js.map