import { CommonModule } from '@angular/common';
import { Injectable, ChangeDetectionStrategy, Component, Input, ViewChild, defineInjectable, NgModule } from '@angular/core';
import { MatMenuTrigger, MatMenuModule } from '@angular/material';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxMatPopoverService = /** @class */ (function () {
    function NgxMatPopoverService() {
    }
    NgxMatPopoverService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxMatPopoverService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxMatPopoverService.ngInjectableDef = defineInjectable({ factory: function NgxMatPopoverService_Factory() { return new NgxMatPopoverService(); }, token: NgxMatPopoverService, providedIn: "root" });
    return NgxMatPopoverService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxMatPopoverComponent = /** @class */ (function () {
    function NgxMatPopoverComponent() {
        this.xPosition = 'after';
        this.yPosition = 'below';
    }
    // for outside call
    // for outside call
    /**
     * @return {?}
     */
    NgxMatPopoverComponent.prototype.open = 
    // for outside call
    /**
     * @return {?}
     */
    function () {
        this.matMenuTrigger.openMenu();
    };
    /**
     * @return {?}
     */
    NgxMatPopoverComponent.prototype.close = /**
     * @return {?}
     */
    function () {
        this.matMenuTrigger.closeMenu();
    };
    NgxMatPopoverComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-mat-popover',
                    template: "<mat-menu #popover=\"matMenu\" [xPosition]=\"xPosition\" [yPosition]=\"yPosition\" class=\"ngm-popover\">\n  <ng-template matMenuContent>\n    <span mat-menu-item [disableRipple]=\"true\" (click)=\"$event.stopPropagation()\" class=\"mat-popover\">\n      <!-- popover content begin -->\n      <ng-container *ngTemplateOutlet=\"popoverContent\"></ng-container>\n      <!-- popover content end  -->\n    </span>\n  </ng-template>\n</mat-menu>\n<div [matMenuTriggerFor]=\"popover\">\n  <ng-content></ng-content>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    exportAs: 'ngxMatPopover'
                }] }
    ];
    NgxMatPopoverComponent.propDecorators = {
        xPosition: [{ type: Input }],
        yPosition: [{ type: Input }],
        popoverContent: [{ type: Input }],
        matMenuTrigger: [{ type: ViewChild, args: [MatMenuTrigger,] }]
    };
    return NgxMatPopoverComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxMatPopoverModule = /** @class */ (function () {
    function NgxMatPopoverModule() {
    }
    NgxMatPopoverModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxMatPopoverComponent],
                    imports: [CommonModule, MatMenuModule],
                    exports: [NgxMatPopoverComponent]
                },] }
    ];
    return NgxMatPopoverModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxMatPopoverService, NgxMatPopoverComponent, NgxMatPopoverModule };

//# sourceMappingURL=ngx-mat-popover.js.map